Index: build/premake4.lua
===================================================================
--- build/premake4.lua	(revision 1903)
+++ build/premake4.lua	(working copy)
@@ -32,6 +32,8 @@
     "kinematic",
     "motion",
     "motor",
+    "amplus",
+    "lmplus",
     "ode",
     "piston",
     "plane2d",
Index: include/ode/amplus_api.h
===================================================================
--- include/ode/amplus_api.h	(revision 0)
+++ include/ode/amplus_api.h	(working copy)
@@ -0,0 +1,242 @@
+/*************************************************************************
+ *                                                                       *
+ * AMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+
+/**
+ * @brief Create a new joint of the AMPlus type.
+ * @ingroup joints
+ * @param dJointGroupID set to 0 to allocate the joint normally.
+ * If it is nonzero the joint is allocated in the given joint group.
+ */
+ODE_API dJointID dJointCreateAMPlus (dWorldID, dJointGroupID);
+
+/**
+ * @brief set joint parameter
+ * @remarks This is how the degree of freedom is controlled
+ * if the histop==lostop then the constraint is a hard constraint
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusParam( dJointID j, int parameter, dReal value );
+
+/**
+ * @brief get joint parameter
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetAMPlusParam( dJointID j, int parameter );
+
+/**
+ * @brief Set an AMPlus anchor axis for the first body.
+ * @param anum selects the axis to change (0,1 or 2).
+ * @remarks The axis vector is specified in global coordinates but
+ * will be stored relative to the first body
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusAxis1( dJointID j, int anum, dReal x, dReal y, dReal z);
+
+/**
+ * @brief Set an AMPlus anchor axis for the first body.
+ * @param anum selects the axis to change (0,1 or 2).
+ * @remarks The axis vector is specified relative to the first body
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusAxis1Rel( dJointID j, int anum, dReal x, dReal y, dReal z);
+ODE_API void dJointSetAMPlusAxis1V( dJointID j, int anum, const dVector3 ax);
+ODE_API void dJointSetAMPlusAxis1RelV( dJointID j, int anum, const dVector3 ax);
+
+/**
+ * @brief Set an AMPlus anchor axis for the second body.
+ * @param anum selects the axis to change (0,1 or 2).
+ * @remarks The axis vector is specified in global coordinates but
+ * will be stored relative to the second body
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusAxis2( dJointID j, int anum, dReal x, dReal y, dReal z);
+
+/**
+ * @brief Set an AMPlus anchor axis for the second body.
+ * @param anum selects the axis to change (0,1 or 2).
+ * @remarks The axis vector is specified relative to the second body
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusAxis2Rel( dJointID j, int anum, dReal x, dReal y, dReal z);
+ODE_API void dJointSetAMPlusAxis2V( dJointID j, int anum, const dVector3 ax);
+ODE_API void dJointSetAMPlusAxis2RelV( dJointID j, int anum, const dVector3 ax);
+
+/**
+ * @brief Set the AMPlus reference axis.
+ * @param anum selects the axis to change (0, 1 or 2).
+ * @param frame Each axis can have one of two ``relative orientations'' 
+ * \li 1: The axis is anchored to the first body.
+ * \li 2: The axis is anchored to the second body.
+ * @remarks This defines the axis of rotation in projected mode
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusAxisRef( dJointID j, int anum, int frame,  dReal x, dReal y, dReal z);
+ODE_API void dJointSetAMPlusAxisRefRel( dJointID j, int anum, int frame,  dReal x, dReal y, dReal z);
+ODE_API void dJointSetAMPlusAxisRefV( dJointID j, int anum, int frame, const dVector3 ax);
+ODE_API void dJointSetAMPlusAxisRefRelV( dJointID j, int anum, int frame, const dVector3 ax);
+
+/**
+ * @brief set AMPlus mode for the specified axis
+ * @param anum selects the axis to change (0,1 or 2).
+ * @ingroup joints
+ * @param mode Each axis can have one of two angle modes
+ * \li dAMPlusCone: The joint constrains the absolute angle between 
+ * the two anchor axes.
+ * \li dAMPlusProjected: The joint constrains the angle between 
+ * the projection of the two anchor axes onto the planespace 
+ * orthogonal to the reference axis.  The reference axis is the
+ * the axis of rotation.
+ */
+ODE_API void dJointSetAMPlusMode( dJointID j, int anum, int mode);
+
+/**
+ * @brief This convenience function establishes the angular 
+ * portion of a hinge constraint between two bodies 
+ * @remarks
+ * Axis 0 and Axis 1 become constraints to keep the hinge 
+ * axis aligned relative to the two bodies
+ * Axis 2 becomes a projection constraint that controls the
+ * hinge angle
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusHinge( dJointID j, dReal x, dReal y, dReal z);
+ODE_API void dJointSetAMPlusHingeV( dJointID j, const dVector3 ax);
+
+/**
+ * @brief This convenience function establishes the angular 
+ * portion of a universal constraint between two bodies 
+ * @remarks
+ * Axis 0 becomes a constraint to keep the crosspiece axes orthogonal
+ * Axes 1 and 2 control rotation around the two degrees of freedom
+ * @ingroup joints
+ */
+ODE_API void dJointSetAMPlusUniversal( dJointID j, dReal x1, dReal y1, dReal z1,
+																			dReal x2, dReal y2, dReal z2);
+ODE_API void dJointSetAMPlusUniversalV( dJointID j, const dVector3 ax1, const dVector3 ax2);
+
+/**
+ * @brief get anchor axis for body 1
+ * @param anum selects the axis (0,1 or 2).
+ * @remarks The axis is transformed to world coordinates 
+ * and stored in @param res
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxis1( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief get anchor axis for body 1
+ * @param anum selects the axis (0,1 or 2).
+ * @remarks The axis is kept in body1 coordinates 
+ * and copied to @param res
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxis1Rel( const dJointID j, int anum, dVector3 res);
+/**
+ * @brief get anchor axis for body 2
+ * @param anum selects the axis (0,1 or 2).
+ * @remarks The axis is transformed to world coordinates 
+ * and stored in @param res
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxis2( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief get anchor axis for body 2
+ * @param anum selects the axis (0,1 or 2).
+ * @remarks The axis is kept in body2 coordinates 
+ * and copied to @param res
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxis2Rel( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief get the reference axis
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @remarks The axis is returned in global coordinates
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxisRef( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief get the reference axis
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @remarks The axis is returned in whatever frames it set to
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusAxisRefRel( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief get the frame for the reference axis
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @ingroup joints
+ */
+ODE_API int dJointGetAMPlusAxisRefFrame( const dJointID j, int anum);
+
+/**
+ * @brief get the mode for the specified degree of freedom
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @ingroup joints
+ */
+ODE_API int dJointGetAMPlusMode( const dJointID j, int anum);
+
+/**
+ * @brief Find the effective axis of rotation for the specified
+ * degree of freedom
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @remarks In Cone mode, the effective axis is the 
+ * cross-product of the two axes.  In Projected mode,
+ * it's the reference axis.
+ * @ingroup joints
+ */
+ODE_API void dJointGetAMPlusEffectiveAxis( const dJointID j, int anum, dVector3 res );
+
+/**
+ * @brief get angle between the anchor axes
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @remarks In cone mode, the angle is the arccos of
+ * the dot-product of the two anchor axes.  In projected
+ * mode, the angle is how far one anchor axis is rotated
+ * around from reference axis from the other anchor axis. 
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetAMPlusAngle( const dJointID j, int anum );
+
+/**
+ * @brief Get the angle time derivative.
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetAMPlusAngleRate( const dJointID j, int anum );
+
+/**
+ * @brief Applies the torque about the effective axis.
+ * @param anum selects the degree of freedom (0,1 or 2).
+ * @remarks 
+ * It applies a torque with specified magnitude in the direction
+ * of the effective axis, to body 1, and with the same magnitude but in opposite
+ * direction to body 2. This function is just a wrapper for dBodyAddTorque()}
+ * @ingroup joints
+ */
+ODE_API void dJointAddAMPlusTorque(dJointID j,int anum, dReal torque);
+
+
Index: include/ode/common.h
===================================================================
--- include/ode/common.h	(revision 1903)
+++ include/ode/common.h	(working copy)
@@ -110,6 +110,7 @@
 #define dCos(x) (cosf(x))				/* cosine */
 #define dFabs(x) (fabsf(x))			/* absolute value */
 #define dAtan2(y,x) (atan2f(y,x))		/* arc tangent with 2 args */
+#define dAcos(x) (acosf(x))
 #define dFMod(a,b) (fmodf(a,b))		/* modulo */
 #define dFloor(x) floorf(x)			/* floor */
 #define dCeil(x) ceilf(x)			/* ceil */
@@ -145,6 +146,7 @@
 #define dCos(x) cos(x)
 #define dFabs(x) fabs(x)
 #define dAtan2(y,x) atan2((y),(x))
+#define dAcos(x) acos(x)
 #define dFMod(a,b) (fmod((a),(b)))
 #define dFloor(x) floor(x)
 #define dCeil(x) ceil(x)
@@ -213,7 +215,9 @@
   dJointTypePU,
   dJointTypePiston,
   dJointTypeDBall,
-  dJointTypeDHinge
+  dJointTypeDHinge,
+  dJointTypeLMPlus,
+  dJointTypeAMPlus,
 } dJointType;
 
 
@@ -255,6 +259,8 @@
   dParamLoStop = start, \
   dParamHiStop, \
   dParamVel, \
+  dParamLoVel, \
+  dParamHiVel, \
   dParamFMax, \
   dParamFudgeFactor, \
   dParamBounce, \
@@ -280,6 +286,8 @@
   dParamLoStop ## x = start, \
   dParamHiStop ## x, \
   dParamVel ## x, \
+  dParamLoVel ## x, \
+  dParamHiVel ## x, \
   dParamFMax ## x, \
   dParamFudgeFactor ## x, \
   dParamBounce ## x, \
@@ -312,7 +320,19 @@
   dAMotorEuler = 1
 };
 
+/* LMPlus mode numbers */
+enum {
+	dLMPlusPlanar = 0,
+	dLMPlusCylindrical,
+	dLMPlusSpherical
+};
 
+/* AMPlus mode numbers */
+enum {
+  dAMPlusCone = 0,
+  dAMPlusProjected
+};
+
 /* joint force feedback information */
 
 typedef struct dJointFeedback {
Index: include/ode/lmplus_api.h
===================================================================
--- include/ode/lmplus_api.h	(revision 0)
+++ include/ode/lmplus_api.h	(working copy)
@@ -0,0 +1,192 @@
+/*************************************************************************
+ *                                                                       *
+ * LMPlus for Open Dynamics Engine.  Copyright (C) 2012 Joseph Cooper.   *
+ *                                                                       *
+ *                                                                       *
+ * This library is free software; you can redistribute it and/or         *
+ * modify it under the terms of EITHER:                                  *
+ *   (1) The GNU Lesser General Public License as published by the Free  *
+ *       Software Foundation; either version 2.1 of the License, or (at  *
+ *       your option) any later version. The text of the GNU Lesser      *
+ *       General Public License is included with this library in the     *
+ *       file LICENSE.TXT.                                               *
+ *   (2) The BSD-style license that is included with this library in     *
+ *       the file LICENSE-BSD.TXT.                                       *
+ *   (3) The zlib/libpng license that is included with this library in   *
+ *       the file LICENSE-ZLIB.TXT                                       *
+ *                                                                       *
+ * This library is distributed WITHOUT ANY WARRANTY, including implied   *
+ * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.      *
+ * See the files LICENSE.TXT or LICENSE-BSD.TXT or LICENSE-ZLIB.TXT      *
+ *                                                                       *
+ *************************************************************************/
+
+
+/**
+ * @brief Create a new joint of the LMPlus type.
+ * @ingroup joints
+ * @param dJointGroupID set to 0 to allocate the joint normally.
+ * If it is nonzero the joint is allocated in the given joint group.
+ */
+ODE_API dJointID dJointCreateLMPlus (dWorldID, dJointGroupID);
+
+/**
+ * @brief set joint parameter
+ * @remarks This is how the degree of freedom is controlled
+ * if the histop==lostop then the constraint is a hard constraint
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusParam( dJointID j, int parameter, dReal value );
+
+/**
+ * @brief get joint parameter
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetLMPlusParam( dJointID j, int parameter );
+
+/**
+ * @brief set the anchors for both bodies
+ * @remarks the anchor points are expected to be in global coordinates
+ * the distance between the anchors will be constrained along
+ * the specified axis.
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusAnchors( dJointID j, dReal x1, dReal y1, dReal z1, dReal x2, dReal y2, dReal z2);
+ODE_API void dJointSetLMPlusAnchorsV( dJointID j, const dVector3 a1, const dVector3 a2);
+ODE_API void dJointSetLMPlusAnchorsRel( dJointID j, dReal x1, dReal y1, dReal z1, dReal x2, dReal y2, dReal z2);
+ODE_API void dJointSetLMPlusAnchorsRelV( dJointID j, const dVector3 a1, const dVector3 a2);
+
+/**
+ * @brief set the anchors for the first body
+ * @remarks the anchor point is expected to be in global coordinates
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusAnchor1( dJointID j, dReal x1, dReal y1, dReal z1);
+ODE_API void dJointSetLMPlusAnchor1V( dJointID j, const dVector3 a1);
+ODE_API void dJointSetLMPlusAnchor1Rel( dJointID j, dReal x1, dReal y1, dReal z1);
+ODE_API void dJointSetLMPlusAnchor1RelV( dJointID j, const dVector3 a1);
+
+/**
+ * @brief set the anchors for the second body
+ * @remarks the anchor point is expected to be in global coordinates
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusAnchor2( dJointID j, dReal x2, dReal y2, dReal z2);
+ODE_API void dJointSetLMPlusAnchor2V( dJointID j, const dVector3 a2);
+ODE_API void dJointSetLMPlusAnchor2Rel( dJointID j, dReal x2, dReal y2, dReal z2);
+ODE_API void dJointSetLMPlusAnchor2RelV( dJointID j, const dVector3 a2);
+
+/**
+ * @brief Set the LMPlus axis.
+ * @param anum selects the axis to change (0, 1 or 2).
+ * @param frame Each axis can be fixed relative to one of three reference frames
+ * \li 0: The axis is anchored to the world.
+ * \li 1: The axis is anchored to the first body.
+ * \li 2: The axis is anchored to the second body.
+ * @remarks This defines the axis of constraint for the two anchor points
+ * This function is unnecessary for spherical mode
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusAxis( dJointID j, int anum, int frame,  dReal x, dReal y, dReal z);
+ODE_API void dJointSetLMPlusAxisV( dJointID j, int anum, int frame, const dVector3 ax);
+ODE_API void dJointSetLMPlusAxisRel( dJointID j, int anum, int frame,  dReal x, dReal y, dReal z);
+ODE_API void dJointSetLMPlusAxisRelV( dJointID j, int anum, int frame, const dVector3 ax);
+
+/**
+ * @brief set AMPlus mode for the specified axis
+ * @param anum selects the axis to change (0,1 or 2).
+ * 
+ * @param mode Each axis can have one of three modes
+ * \li dLMPlusPlanar: The directed distance between the anchor points
+ * along the specifed axis is constrained.  If the distance is set
+ * to zero, a single constraint axis keeps the anchors in
+ * the same plane.
+ * \li dLMPlusCylindrical: The absolute distance between the anchor
+ * points projected onto a plane orthogonal to the specified axis is
+ * constrained.  If the distance is set to a constant, then one anchor
+ * point is kept on the surface of an infinite cylinder relative to the other.
+ * \li dLMPlusSpherical: The absolute distance between the anchor
+ * points is constrained.  The axis specified for this @param anum has
+ * no effect.  If the distance is set to a constant, then one anchor
+ * point is kept on the surface of a sphere relative to the other.
+ * @ingroup joints
+ */
+ODE_API void dJointSetLMPlusMode( dJointID j, int anum, int mode);
+
+/**
+ * @brief Get the LMPlus anchor point for body1, in world coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAnchor1( const dJointID j, dVector3 res);
+
+/**
+ * @brief Get the LMPlus anchor point for body1, in body1 coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAnchor1Rel( const dJointID j, dVector3 res);
+
+/**
+ * @brief Get the LMPlus anchor point for body2, in world coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAnchor2( const dJointID j, dVector3 res);
+
+/**
+ * @brief Get the LMPlus anchor point for body2, in body2 coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAnchor2Rel( const dJointID j, dVector3 res);
+
+/**
+ * @brief Get the LMPlus axis for degree of freedom specified by @param anum (0,1,2)
+ * In world coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAxis( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief Get the LMPlus axis for degree of freedom specified by @param anum (0,1,2)
+ * In the DoF's specified FoR's coordinates.
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusAxisRel( const dJointID j, int anum, dVector3 res);
+
+/**
+ * @brief Get the frame of reference designated for the degree of freedom
+ * specified by @param anum
+ * @ingroup joints
+ */
+ODE_API int dJointGetLMPlusAxisFrame( const dJointID j, int anum);
+
+/**
+ * @brief Get the mode (planar, cylindrical, spherical) designated 
+ * for the degree of freedom specified by @param anum (0,1,2)
+ * @ingroup joints
+ */
+ODE_API int dJointGetLMPlusMode( const dJointID j, int anum);
+
+/**
+ * @brief Get the effective axis of constraint
+ * In Planar mode, this is the same as GetLMPlusAxis.
+ * In Spherical mode, this will be the normalized vector between the
+ * two anchor points.
+ * In Cylindrical mode, this be the projection of the vector
+ * between the two anchor points onto the plane defined by
+ * by the axis
+ * @ingroup joints
+ */
+ODE_API void dJointGetLMPlusEffectiveAxis( const dJointID j, int anum, dVector3 res );
+
+/**
+ * @brief The distance between the anchor points along the effective axis.
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetLMPlusSeparation( const dJointID j, int anum );
+
+/**
+ * @brief Time derivative of teh distance between the anchor points along the 
+ * effective axis.
+ * @ingroup joints
+ */
+ODE_API dReal dJointGetLMPlusSeparationRate( const dJointID j, int anum );
+
Index: include/ode/Makefile.am
===================================================================
--- include/ode/Makefile.am	(revision 1903)
+++ include/ode/Makefile.am	(working copy)
@@ -15,6 +15,8 @@
 				collision.h \
 				error.h \
 				objects.h \
+                        amplus_api.h \
+                        lmplus_api.h \
 				rotation.h \
 				collision_space.h \
 				export-dif.h \
Index: include/ode/objects.h
===================================================================
--- include/ode/objects.h	(revision 1903)
+++ include/ode/objects.h	(working copy)
@@ -3105,6 +3105,9 @@
  */
 ODE_API dReal dJointGetDHingeParam(dJointID, int parameter);
 
+/* The objects.h file is way too big. */
+#include <ode/lmplus_api.h>
+#include <ode/amplus_api.h>
 
 
 
Index: include/ode/odemath.h
===================================================================
--- include/ode/odemath.h	(revision 1903)
+++ include/ode/odemath.h	(working copy)
@@ -423,6 +423,17 @@
  */
 
 ODE_API void dPlaneSpace (const dVector3 n, dVector3 p, dVector3 q);
+
+/*
+ * Given unit normal vector 'n', find normalized projection 'p' of vector
+ * 'd' onto the planespace and orthonormal vector 'q'.
+ * If 'n' is parallel to 'd', then this will be the same as dPlaneSpace
+ * and return value will be 0.
+ * Otherwise, return value is 1.
+ */
+ODE_API int dDirectedPlaneSpace  (const dVector3 n, const dVector3 d, dVector3 p, dVector3 q);
+
+
 /* Makes sure the matrix is a proper rotation */
 ODE_API void dOrthogonalizeR(dMatrix3 m);
 
